# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class AccessCodeStatus(str, enum.Enum):
    UNSET = "unset"
    """
    The time frame for an access code has not begun; the code is not set
    """

    SETTING = "setting"
    """
    The code is being set
    """

    SET = "set"
    """
    The code has been set
    """

    REMOVING = "removing"
    """
    The code is being removed
    """

    def visit(
        self,
        unset: typing.Callable[[], T_Result],
        setting: typing.Callable[[], T_Result],
        set: typing.Callable[[], T_Result],
        removing: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is AccessCodeStatus.UNSET:
            return unset()
        if self is AccessCodeStatus.SETTING:
            return setting()
        if self is AccessCodeStatus.SET:
            return set()
        if self is AccessCodeStatus.REMOVING:
            return removing()
